/*
 * RTLinux scheduling accuracy measuring example, user program
 *
 * (C) Michael Barabanov, 1997
 *  (C) FSMLabs  1999. baraban@fsmlabs.com
 *  Released under the GNU GENERAL PUBLIC LICENSE Version 2, June 1991
 *  Any use of this code must include this notice.
 */

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <rtl_fifo.h>
#include "common.h"

int 
main(int argc,char ** argv)
{
	int fd0;
	int n;
	int samples=1000;
	struct sample samp;

  	while (--argc > 0 && (*++argv)[0] == '-') {
		switch ((*argv)[1]) {
		case 's':
			if (--argc <= 0){
				printf("-s needs a number of samples\n");
				return -1;
				}
      			samples = atoi(*++argv);
			break;
		default:
			printf("./monitor [-s NUM_SAMPLES]\n");
			break;
		}
	}
	
	if ((fd0 = open("/dev/rtf0", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf0\n");
		exit(1);
	}


	while(samples--){
		n = read(fd0, &samp, sizeof(samp));
		printf("min: %8d, max: %8d\n", (int) samp.min, (int) samp.max);
		fflush(stdout);
	}

	return 0;
}
